// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: capbankmodule/capbankmodule.proto

package openfmb.capbankmodule;

/**
 * <pre>
 * LN: Power cap bank  Name: YPSH
 * </pre>
 *
 * Protobuf type {@code capbankmodule.CapBankEventAndStatusYPSH}
 */
public final class CapBankEventAndStatusYPSH extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:capbankmodule.CapBankEventAndStatusYPSH)
    CapBankEventAndStatusYPSHOrBuilder {
private static final long serialVersionUID = 0L;
  // Use CapBankEventAndStatusYPSH.newBuilder() to construct.
  private CapBankEventAndStatusYPSH(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private CapBankEventAndStatusYPSH() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new CapBankEventAndStatusYPSH();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankEventAndStatusYPSH_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankEventAndStatusYPSH_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.capbankmodule.CapBankEventAndStatusYPSH.class, openfmb.capbankmodule.CapBankEventAndStatusYPSH.Builder.class);
  }

  public static final int LOGICALNODEFOREVENTANDSTATUS_FIELD_NUMBER = 1;
  private openfmb.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the logicalNodeForEventAndStatus field is set.
   */
  @java.lang.Override
  public boolean hasLogicalNodeForEventAndStatus() {
    return logicalNodeForEventAndStatus_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
   * @return The logicalNodeForEventAndStatus.
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeForEventAndStatus getLogicalNodeForEventAndStatus() {
    return logicalNodeForEventAndStatus_ == null ? openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder getLogicalNodeForEventAndStatusOrBuilder() {
    return logicalNodeForEventAndStatus_ == null ? openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
  }

  public static final int AMPLMT_FIELD_NUMBER = 2;
  private openfmb.commonmodule.PhaseSPS ampLmt_;
  /**
   * <pre>
   * True if current limit (high, low, or both) are set
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS AmpLmt = 2;</code>
   * @return Whether the ampLmt field is set.
   */
  @java.lang.Override
  public boolean hasAmpLmt() {
    return ampLmt_ != null;
  }
  /**
   * <pre>
   * True if current limit (high, low, or both) are set
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS AmpLmt = 2;</code>
   * @return The ampLmt.
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseSPS getAmpLmt() {
    return ampLmt_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : ampLmt_;
  }
  /**
   * <pre>
   * True if current limit (high, low, or both) are set
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS AmpLmt = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseSPSOrBuilder getAmpLmtOrBuilder() {
    return ampLmt_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : ampLmt_;
  }

  public static final int CTLMODE_FIELD_NUMBER = 3;
  private openfmb.commonmodule.Optional_ControlModeKind ctlMode_;
  /**
   * <pre>
   * Control mode
   * </pre>
   *
   * <code>.commonmodule.Optional_ControlModeKind CtlMode = 3;</code>
   * @return Whether the ctlMode field is set.
   */
  @java.lang.Override
  public boolean hasCtlMode() {
    return ctlMode_ != null;
  }
  /**
   * <pre>
   * Control mode
   * </pre>
   *
   * <code>.commonmodule.Optional_ControlModeKind CtlMode = 3;</code>
   * @return The ctlMode.
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_ControlModeKind getCtlMode() {
    return ctlMode_ == null ? openfmb.commonmodule.Optional_ControlModeKind.getDefaultInstance() : ctlMode_;
  }
  /**
   * <pre>
   * Control mode
   * </pre>
   *
   * <code>.commonmodule.Optional_ControlModeKind CtlMode = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_ControlModeKindOrBuilder getCtlModeOrBuilder() {
    return ctlMode_ == null ? openfmb.commonmodule.Optional_ControlModeKind.getDefaultInstance() : ctlMode_;
  }

  public static final int DIRREV_FIELD_NUMBER = 4;
  private openfmb.commonmodule.PhaseSPS dirRev_;
  /**
   * <pre>
   * True if power flow is reversed
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS DirRev = 4;</code>
   * @return Whether the dirRev field is set.
   */
  @java.lang.Override
  public boolean hasDirRev() {
    return dirRev_ != null;
  }
  /**
   * <pre>
   * True if power flow is reversed
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS DirRev = 4;</code>
   * @return The dirRev.
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseSPS getDirRev() {
    return dirRev_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : dirRev_;
  }
  /**
   * <pre>
   * True if power flow is reversed
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS DirRev = 4;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseSPSOrBuilder getDirRevOrBuilder() {
    return dirRev_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : dirRev_;
  }

  public static final int DYNAMICTEST_FIELD_NUMBER = 5;
  private openfmb.commonmodule.ENS_DynamicTestKind dynamicTest_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 5;</code>
   * @return Whether the dynamicTest field is set.
   */
  @java.lang.Override
  public boolean hasDynamicTest() {
    return dynamicTest_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 5;</code>
   * @return The dynamicTest.
   */
  @java.lang.Override
  public openfmb.commonmodule.ENS_DynamicTestKind getDynamicTest() {
    return dynamicTest_ == null ? openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance() : dynamicTest_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 5;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ENS_DynamicTestKindOrBuilder getDynamicTestOrBuilder() {
    return dynamicTest_ == null ? openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance() : dynamicTest_;
  }

  public static final int POS_FIELD_NUMBER = 6;
  private openfmb.commonmodule.PhaseDPS pos_;
  /**
   * <pre>
   * (controllable) Position of the switch of power shunt.
   * </pre>
   *
   * <code>.commonmodule.PhaseDPS Pos = 6;</code>
   * @return Whether the pos field is set.
   */
  @java.lang.Override
  public boolean hasPos() {
    return pos_ != null;
  }
  /**
   * <pre>
   * (controllable) Position of the switch of power shunt.
   * </pre>
   *
   * <code>.commonmodule.PhaseDPS Pos = 6;</code>
   * @return The pos.
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseDPS getPos() {
    return pos_ == null ? openfmb.commonmodule.PhaseDPS.getDefaultInstance() : pos_;
  }
  /**
   * <pre>
   * (controllable) Position of the switch of power shunt.
   * </pre>
   *
   * <code>.commonmodule.PhaseDPS Pos = 6;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseDPSOrBuilder getPosOrBuilder() {
    return pos_ == null ? openfmb.commonmodule.PhaseDPS.getDefaultInstance() : pos_;
  }

  public static final int TEMPLMT_FIELD_NUMBER = 7;
  private openfmb.commonmodule.PhaseSPS tempLmt_;
  /**
   * <pre>
   * True if temperature limit (high, low, or both) are set
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS TempLmt = 7;</code>
   * @return Whether the tempLmt field is set.
   */
  @java.lang.Override
  public boolean hasTempLmt() {
    return tempLmt_ != null;
  }
  /**
   * <pre>
   * True if temperature limit (high, low, or both) are set
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS TempLmt = 7;</code>
   * @return The tempLmt.
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseSPS getTempLmt() {
    return tempLmt_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : tempLmt_;
  }
  /**
   * <pre>
   * True if temperature limit (high, low, or both) are set
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS TempLmt = 7;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseSPSOrBuilder getTempLmtOrBuilder() {
    return tempLmt_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : tempLmt_;
  }

  public static final int VARLMT_FIELD_NUMBER = 8;
  private openfmb.commonmodule.PhaseSPS vArLmt_;
  /**
   * <pre>
   * True if VAr limit (high, low, or both) are set
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS VArLmt = 8;</code>
   * @return Whether the vArLmt field is set.
   */
  @java.lang.Override
  public boolean hasVArLmt() {
    return vArLmt_ != null;
  }
  /**
   * <pre>
   * True if VAr limit (high, low, or both) are set
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS VArLmt = 8;</code>
   * @return The vArLmt.
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseSPS getVArLmt() {
    return vArLmt_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : vArLmt_;
  }
  /**
   * <pre>
   * True if VAr limit (high, low, or both) are set
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS VArLmt = 8;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseSPSOrBuilder getVArLmtOrBuilder() {
    return vArLmt_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : vArLmt_;
  }

  public static final int VOLLMT_FIELD_NUMBER = 9;
  private openfmb.commonmodule.PhaseSPS volLmt_;
  /**
   * <pre>
   * True if voltage limit (high, low, or both) are set
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS VolLmt = 9;</code>
   * @return Whether the volLmt field is set.
   */
  @java.lang.Override
  public boolean hasVolLmt() {
    return volLmt_ != null;
  }
  /**
   * <pre>
   * True if voltage limit (high, low, or both) are set
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS VolLmt = 9;</code>
   * @return The volLmt.
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseSPS getVolLmt() {
    return volLmt_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : volLmt_;
  }
  /**
   * <pre>
   * True if voltage limit (high, low, or both) are set
   * </pre>
   *
   * <code>.commonmodule.PhaseSPS VolLmt = 9;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseSPSOrBuilder getVolLmtOrBuilder() {
    return volLmt_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : volLmt_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (logicalNodeForEventAndStatus_ != null) {
      output.writeMessage(1, getLogicalNodeForEventAndStatus());
    }
    if (ampLmt_ != null) {
      output.writeMessage(2, getAmpLmt());
    }
    if (ctlMode_ != null) {
      output.writeMessage(3, getCtlMode());
    }
    if (dirRev_ != null) {
      output.writeMessage(4, getDirRev());
    }
    if (dynamicTest_ != null) {
      output.writeMessage(5, getDynamicTest());
    }
    if (pos_ != null) {
      output.writeMessage(6, getPos());
    }
    if (tempLmt_ != null) {
      output.writeMessage(7, getTempLmt());
    }
    if (vArLmt_ != null) {
      output.writeMessage(8, getVArLmt());
    }
    if (volLmt_ != null) {
      output.writeMessage(9, getVolLmt());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (logicalNodeForEventAndStatus_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getLogicalNodeForEventAndStatus());
    }
    if (ampLmt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getAmpLmt());
    }
    if (ctlMode_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getCtlMode());
    }
    if (dirRev_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getDirRev());
    }
    if (dynamicTest_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getDynamicTest());
    }
    if (pos_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, getPos());
    }
    if (tempLmt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(7, getTempLmt());
    }
    if (vArLmt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(8, getVArLmt());
    }
    if (volLmt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(9, getVolLmt());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.capbankmodule.CapBankEventAndStatusYPSH)) {
      return super.equals(obj);
    }
    openfmb.capbankmodule.CapBankEventAndStatusYPSH other = (openfmb.capbankmodule.CapBankEventAndStatusYPSH) obj;

    if (hasLogicalNodeForEventAndStatus() != other.hasLogicalNodeForEventAndStatus()) return false;
    if (hasLogicalNodeForEventAndStatus()) {
      if (!getLogicalNodeForEventAndStatus()
          .equals(other.getLogicalNodeForEventAndStatus())) return false;
    }
    if (hasAmpLmt() != other.hasAmpLmt()) return false;
    if (hasAmpLmt()) {
      if (!getAmpLmt()
          .equals(other.getAmpLmt())) return false;
    }
    if (hasCtlMode() != other.hasCtlMode()) return false;
    if (hasCtlMode()) {
      if (!getCtlMode()
          .equals(other.getCtlMode())) return false;
    }
    if (hasDirRev() != other.hasDirRev()) return false;
    if (hasDirRev()) {
      if (!getDirRev()
          .equals(other.getDirRev())) return false;
    }
    if (hasDynamicTest() != other.hasDynamicTest()) return false;
    if (hasDynamicTest()) {
      if (!getDynamicTest()
          .equals(other.getDynamicTest())) return false;
    }
    if (hasPos() != other.hasPos()) return false;
    if (hasPos()) {
      if (!getPos()
          .equals(other.getPos())) return false;
    }
    if (hasTempLmt() != other.hasTempLmt()) return false;
    if (hasTempLmt()) {
      if (!getTempLmt()
          .equals(other.getTempLmt())) return false;
    }
    if (hasVArLmt() != other.hasVArLmt()) return false;
    if (hasVArLmt()) {
      if (!getVArLmt()
          .equals(other.getVArLmt())) return false;
    }
    if (hasVolLmt() != other.hasVolLmt()) return false;
    if (hasVolLmt()) {
      if (!getVolLmt()
          .equals(other.getVolLmt())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasLogicalNodeForEventAndStatus()) {
      hash = (37 * hash) + LOGICALNODEFOREVENTANDSTATUS_FIELD_NUMBER;
      hash = (53 * hash) + getLogicalNodeForEventAndStatus().hashCode();
    }
    if (hasAmpLmt()) {
      hash = (37 * hash) + AMPLMT_FIELD_NUMBER;
      hash = (53 * hash) + getAmpLmt().hashCode();
    }
    if (hasCtlMode()) {
      hash = (37 * hash) + CTLMODE_FIELD_NUMBER;
      hash = (53 * hash) + getCtlMode().hashCode();
    }
    if (hasDirRev()) {
      hash = (37 * hash) + DIRREV_FIELD_NUMBER;
      hash = (53 * hash) + getDirRev().hashCode();
    }
    if (hasDynamicTest()) {
      hash = (37 * hash) + DYNAMICTEST_FIELD_NUMBER;
      hash = (53 * hash) + getDynamicTest().hashCode();
    }
    if (hasPos()) {
      hash = (37 * hash) + POS_FIELD_NUMBER;
      hash = (53 * hash) + getPos().hashCode();
    }
    if (hasTempLmt()) {
      hash = (37 * hash) + TEMPLMT_FIELD_NUMBER;
      hash = (53 * hash) + getTempLmt().hashCode();
    }
    if (hasVArLmt()) {
      hash = (37 * hash) + VARLMT_FIELD_NUMBER;
      hash = (53 * hash) + getVArLmt().hashCode();
    }
    if (hasVolLmt()) {
      hash = (37 * hash) + VOLLMT_FIELD_NUMBER;
      hash = (53 * hash) + getVolLmt().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.capbankmodule.CapBankEventAndStatusYPSH parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.capbankmodule.CapBankEventAndStatusYPSH parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankEventAndStatusYPSH parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.capbankmodule.CapBankEventAndStatusYPSH parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankEventAndStatusYPSH parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.capbankmodule.CapBankEventAndStatusYPSH parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankEventAndStatusYPSH parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.capbankmodule.CapBankEventAndStatusYPSH parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankEventAndStatusYPSH parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.capbankmodule.CapBankEventAndStatusYPSH parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankEventAndStatusYPSH parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.capbankmodule.CapBankEventAndStatusYPSH parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.capbankmodule.CapBankEventAndStatusYPSH prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * LN: Power cap bank  Name: YPSH
   * </pre>
   *
   * Protobuf type {@code capbankmodule.CapBankEventAndStatusYPSH}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:capbankmodule.CapBankEventAndStatusYPSH)
      openfmb.capbankmodule.CapBankEventAndStatusYPSHOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankEventAndStatusYPSH_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankEventAndStatusYPSH_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.capbankmodule.CapBankEventAndStatusYPSH.class, openfmb.capbankmodule.CapBankEventAndStatusYPSH.Builder.class);
    }

    // Construct using openfmb.capbankmodule.CapBankEventAndStatusYPSH.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      logicalNodeForEventAndStatus_ = null;
      if (logicalNodeForEventAndStatusBuilder_ != null) {
        logicalNodeForEventAndStatusBuilder_.dispose();
        logicalNodeForEventAndStatusBuilder_ = null;
      }
      ampLmt_ = null;
      if (ampLmtBuilder_ != null) {
        ampLmtBuilder_.dispose();
        ampLmtBuilder_ = null;
      }
      ctlMode_ = null;
      if (ctlModeBuilder_ != null) {
        ctlModeBuilder_.dispose();
        ctlModeBuilder_ = null;
      }
      dirRev_ = null;
      if (dirRevBuilder_ != null) {
        dirRevBuilder_.dispose();
        dirRevBuilder_ = null;
      }
      dynamicTest_ = null;
      if (dynamicTestBuilder_ != null) {
        dynamicTestBuilder_.dispose();
        dynamicTestBuilder_ = null;
      }
      pos_ = null;
      if (posBuilder_ != null) {
        posBuilder_.dispose();
        posBuilder_ = null;
      }
      tempLmt_ = null;
      if (tempLmtBuilder_ != null) {
        tempLmtBuilder_.dispose();
        tempLmtBuilder_ = null;
      }
      vArLmt_ = null;
      if (vArLmtBuilder_ != null) {
        vArLmtBuilder_.dispose();
        vArLmtBuilder_ = null;
      }
      volLmt_ = null;
      if (volLmtBuilder_ != null) {
        volLmtBuilder_.dispose();
        volLmtBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankEventAndStatusYPSH_descriptor;
    }

    @java.lang.Override
    public openfmb.capbankmodule.CapBankEventAndStatusYPSH getDefaultInstanceForType() {
      return openfmb.capbankmodule.CapBankEventAndStatusYPSH.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.capbankmodule.CapBankEventAndStatusYPSH build() {
      openfmb.capbankmodule.CapBankEventAndStatusYPSH result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.capbankmodule.CapBankEventAndStatusYPSH buildPartial() {
      openfmb.capbankmodule.CapBankEventAndStatusYPSH result = new openfmb.capbankmodule.CapBankEventAndStatusYPSH(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.capbankmodule.CapBankEventAndStatusYPSH result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.logicalNodeForEventAndStatus_ = logicalNodeForEventAndStatusBuilder_ == null
            ? logicalNodeForEventAndStatus_
            : logicalNodeForEventAndStatusBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.ampLmt_ = ampLmtBuilder_ == null
            ? ampLmt_
            : ampLmtBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.ctlMode_ = ctlModeBuilder_ == null
            ? ctlMode_
            : ctlModeBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.dirRev_ = dirRevBuilder_ == null
            ? dirRev_
            : dirRevBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.dynamicTest_ = dynamicTestBuilder_ == null
            ? dynamicTest_
            : dynamicTestBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000020) != 0)) {
        result.pos_ = posBuilder_ == null
            ? pos_
            : posBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000040) != 0)) {
        result.tempLmt_ = tempLmtBuilder_ == null
            ? tempLmt_
            : tempLmtBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000080) != 0)) {
        result.vArLmt_ = vArLmtBuilder_ == null
            ? vArLmt_
            : vArLmtBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000100) != 0)) {
        result.volLmt_ = volLmtBuilder_ == null
            ? volLmt_
            : volLmtBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.capbankmodule.CapBankEventAndStatusYPSH) {
        return mergeFrom((openfmb.capbankmodule.CapBankEventAndStatusYPSH)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.capbankmodule.CapBankEventAndStatusYPSH other) {
      if (other == openfmb.capbankmodule.CapBankEventAndStatusYPSH.getDefaultInstance()) return this;
      if (other.hasLogicalNodeForEventAndStatus()) {
        mergeLogicalNodeForEventAndStatus(other.getLogicalNodeForEventAndStatus());
      }
      if (other.hasAmpLmt()) {
        mergeAmpLmt(other.getAmpLmt());
      }
      if (other.hasCtlMode()) {
        mergeCtlMode(other.getCtlMode());
      }
      if (other.hasDirRev()) {
        mergeDirRev(other.getDirRev());
      }
      if (other.hasDynamicTest()) {
        mergeDynamicTest(other.getDynamicTest());
      }
      if (other.hasPos()) {
        mergePos(other.getPos());
      }
      if (other.hasTempLmt()) {
        mergeTempLmt(other.getTempLmt());
      }
      if (other.hasVArLmt()) {
        mergeVArLmt(other.getVArLmt());
      }
      if (other.hasVolLmt()) {
        mergeVolLmt(other.getVolLmt());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getLogicalNodeForEventAndStatusFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getAmpLmtFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getCtlModeFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getDirRevFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getDynamicTestFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            case 50: {
              input.readMessage(
                  getPosFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000020;
              break;
            } // case 50
            case 58: {
              input.readMessage(
                  getTempLmtFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000040;
              break;
            } // case 58
            case 66: {
              input.readMessage(
                  getVArLmtFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000080;
              break;
            } // case 66
            case 74: {
              input.readMessage(
                  getVolLmtFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000100;
              break;
            } // case 74
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNodeForEventAndStatus, openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder, openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder> logicalNodeForEventAndStatusBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the logicalNodeForEventAndStatus field is set.
     */
    public boolean hasLogicalNodeForEventAndStatus() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     * @return The logicalNodeForEventAndStatus.
     */
    public openfmb.commonmodule.LogicalNodeForEventAndStatus getLogicalNodeForEventAndStatus() {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        return logicalNodeForEventAndStatus_ == null ? openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
      } else {
        return logicalNodeForEventAndStatusBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNodeForEventAndStatus(openfmb.commonmodule.LogicalNodeForEventAndStatus value) {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        logicalNodeForEventAndStatus_ = value;
      } else {
        logicalNodeForEventAndStatusBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNodeForEventAndStatus(
        openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder builderForValue) {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        logicalNodeForEventAndStatus_ = builderForValue.build();
      } else {
        logicalNodeForEventAndStatusBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeLogicalNodeForEventAndStatus(openfmb.commonmodule.LogicalNodeForEventAndStatus value) {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          logicalNodeForEventAndStatus_ != null &&
          logicalNodeForEventAndStatus_ != openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance()) {
          getLogicalNodeForEventAndStatusBuilder().mergeFrom(value);
        } else {
          logicalNodeForEventAndStatus_ = value;
        }
      } else {
        logicalNodeForEventAndStatusBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearLogicalNodeForEventAndStatus() {
      bitField0_ = (bitField0_ & ~0x00000001);
      logicalNodeForEventAndStatus_ = null;
      if (logicalNodeForEventAndStatusBuilder_ != null) {
        logicalNodeForEventAndStatusBuilder_.dispose();
        logicalNodeForEventAndStatusBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder getLogicalNodeForEventAndStatusBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getLogicalNodeForEventAndStatusFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder getLogicalNodeForEventAndStatusOrBuilder() {
      if (logicalNodeForEventAndStatusBuilder_ != null) {
        return logicalNodeForEventAndStatusBuilder_.getMessageOrBuilder();
      } else {
        return logicalNodeForEventAndStatus_ == null ?
            openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNodeForEventAndStatus, openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder, openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder> 
        getLogicalNodeForEventAndStatusFieldBuilder() {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        logicalNodeForEventAndStatusBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.LogicalNodeForEventAndStatus, openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder, openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder>(
                getLogicalNodeForEventAndStatus(),
                getParentForChildren(),
                isClean());
        logicalNodeForEventAndStatus_ = null;
      }
      return logicalNodeForEventAndStatusBuilder_;
    }

    private openfmb.commonmodule.PhaseSPS ampLmt_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder> ampLmtBuilder_;
    /**
     * <pre>
     * True if current limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS AmpLmt = 2;</code>
     * @return Whether the ampLmt field is set.
     */
    public boolean hasAmpLmt() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * True if current limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS AmpLmt = 2;</code>
     * @return The ampLmt.
     */
    public openfmb.commonmodule.PhaseSPS getAmpLmt() {
      if (ampLmtBuilder_ == null) {
        return ampLmt_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : ampLmt_;
      } else {
        return ampLmtBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * True if current limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS AmpLmt = 2;</code>
     */
    public Builder setAmpLmt(openfmb.commonmodule.PhaseSPS value) {
      if (ampLmtBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ampLmt_ = value;
      } else {
        ampLmtBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if current limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS AmpLmt = 2;</code>
     */
    public Builder setAmpLmt(
        openfmb.commonmodule.PhaseSPS.Builder builderForValue) {
      if (ampLmtBuilder_ == null) {
        ampLmt_ = builderForValue.build();
      } else {
        ampLmtBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if current limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS AmpLmt = 2;</code>
     */
    public Builder mergeAmpLmt(openfmb.commonmodule.PhaseSPS value) {
      if (ampLmtBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          ampLmt_ != null &&
          ampLmt_ != openfmb.commonmodule.PhaseSPS.getDefaultInstance()) {
          getAmpLmtBuilder().mergeFrom(value);
        } else {
          ampLmt_ = value;
        }
      } else {
        ampLmtBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if current limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS AmpLmt = 2;</code>
     */
    public Builder clearAmpLmt() {
      bitField0_ = (bitField0_ & ~0x00000002);
      ampLmt_ = null;
      if (ampLmtBuilder_ != null) {
        ampLmtBuilder_.dispose();
        ampLmtBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if current limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS AmpLmt = 2;</code>
     */
    public openfmb.commonmodule.PhaseSPS.Builder getAmpLmtBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getAmpLmtFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * True if current limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS AmpLmt = 2;</code>
     */
    public openfmb.commonmodule.PhaseSPSOrBuilder getAmpLmtOrBuilder() {
      if (ampLmtBuilder_ != null) {
        return ampLmtBuilder_.getMessageOrBuilder();
      } else {
        return ampLmt_ == null ?
            openfmb.commonmodule.PhaseSPS.getDefaultInstance() : ampLmt_;
      }
    }
    /**
     * <pre>
     * True if current limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS AmpLmt = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder> 
        getAmpLmtFieldBuilder() {
      if (ampLmtBuilder_ == null) {
        ampLmtBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder>(
                getAmpLmt(),
                getParentForChildren(),
                isClean());
        ampLmt_ = null;
      }
      return ampLmtBuilder_;
    }

    private openfmb.commonmodule.Optional_ControlModeKind ctlMode_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_ControlModeKind, openfmb.commonmodule.Optional_ControlModeKind.Builder, openfmb.commonmodule.Optional_ControlModeKindOrBuilder> ctlModeBuilder_;
    /**
     * <pre>
     * Control mode
     * </pre>
     *
     * <code>.commonmodule.Optional_ControlModeKind CtlMode = 3;</code>
     * @return Whether the ctlMode field is set.
     */
    public boolean hasCtlMode() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * Control mode
     * </pre>
     *
     * <code>.commonmodule.Optional_ControlModeKind CtlMode = 3;</code>
     * @return The ctlMode.
     */
    public openfmb.commonmodule.Optional_ControlModeKind getCtlMode() {
      if (ctlModeBuilder_ == null) {
        return ctlMode_ == null ? openfmb.commonmodule.Optional_ControlModeKind.getDefaultInstance() : ctlMode_;
      } else {
        return ctlModeBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Control mode
     * </pre>
     *
     * <code>.commonmodule.Optional_ControlModeKind CtlMode = 3;</code>
     */
    public Builder setCtlMode(openfmb.commonmodule.Optional_ControlModeKind value) {
      if (ctlModeBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ctlMode_ = value;
      } else {
        ctlModeBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control mode
     * </pre>
     *
     * <code>.commonmodule.Optional_ControlModeKind CtlMode = 3;</code>
     */
    public Builder setCtlMode(
        openfmb.commonmodule.Optional_ControlModeKind.Builder builderForValue) {
      if (ctlModeBuilder_ == null) {
        ctlMode_ = builderForValue.build();
      } else {
        ctlModeBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control mode
     * </pre>
     *
     * <code>.commonmodule.Optional_ControlModeKind CtlMode = 3;</code>
     */
    public Builder mergeCtlMode(openfmb.commonmodule.Optional_ControlModeKind value) {
      if (ctlModeBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          ctlMode_ != null &&
          ctlMode_ != openfmb.commonmodule.Optional_ControlModeKind.getDefaultInstance()) {
          getCtlModeBuilder().mergeFrom(value);
        } else {
          ctlMode_ = value;
        }
      } else {
        ctlModeBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control mode
     * </pre>
     *
     * <code>.commonmodule.Optional_ControlModeKind CtlMode = 3;</code>
     */
    public Builder clearCtlMode() {
      bitField0_ = (bitField0_ & ~0x00000004);
      ctlMode_ = null;
      if (ctlModeBuilder_ != null) {
        ctlModeBuilder_.dispose();
        ctlModeBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control mode
     * </pre>
     *
     * <code>.commonmodule.Optional_ControlModeKind CtlMode = 3;</code>
     */
    public openfmb.commonmodule.Optional_ControlModeKind.Builder getCtlModeBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getCtlModeFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Control mode
     * </pre>
     *
     * <code>.commonmodule.Optional_ControlModeKind CtlMode = 3;</code>
     */
    public openfmb.commonmodule.Optional_ControlModeKindOrBuilder getCtlModeOrBuilder() {
      if (ctlModeBuilder_ != null) {
        return ctlModeBuilder_.getMessageOrBuilder();
      } else {
        return ctlMode_ == null ?
            openfmb.commonmodule.Optional_ControlModeKind.getDefaultInstance() : ctlMode_;
      }
    }
    /**
     * <pre>
     * Control mode
     * </pre>
     *
     * <code>.commonmodule.Optional_ControlModeKind CtlMode = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_ControlModeKind, openfmb.commonmodule.Optional_ControlModeKind.Builder, openfmb.commonmodule.Optional_ControlModeKindOrBuilder> 
        getCtlModeFieldBuilder() {
      if (ctlModeBuilder_ == null) {
        ctlModeBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Optional_ControlModeKind, openfmb.commonmodule.Optional_ControlModeKind.Builder, openfmb.commonmodule.Optional_ControlModeKindOrBuilder>(
                getCtlMode(),
                getParentForChildren(),
                isClean());
        ctlMode_ = null;
      }
      return ctlModeBuilder_;
    }

    private openfmb.commonmodule.PhaseSPS dirRev_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder> dirRevBuilder_;
    /**
     * <pre>
     * True if power flow is reversed
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS DirRev = 4;</code>
     * @return Whether the dirRev field is set.
     */
    public boolean hasDirRev() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * True if power flow is reversed
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS DirRev = 4;</code>
     * @return The dirRev.
     */
    public openfmb.commonmodule.PhaseSPS getDirRev() {
      if (dirRevBuilder_ == null) {
        return dirRev_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : dirRev_;
      } else {
        return dirRevBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * True if power flow is reversed
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS DirRev = 4;</code>
     */
    public Builder setDirRev(openfmb.commonmodule.PhaseSPS value) {
      if (dirRevBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        dirRev_ = value;
      } else {
        dirRevBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if power flow is reversed
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS DirRev = 4;</code>
     */
    public Builder setDirRev(
        openfmb.commonmodule.PhaseSPS.Builder builderForValue) {
      if (dirRevBuilder_ == null) {
        dirRev_ = builderForValue.build();
      } else {
        dirRevBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if power flow is reversed
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS DirRev = 4;</code>
     */
    public Builder mergeDirRev(openfmb.commonmodule.PhaseSPS value) {
      if (dirRevBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          dirRev_ != null &&
          dirRev_ != openfmb.commonmodule.PhaseSPS.getDefaultInstance()) {
          getDirRevBuilder().mergeFrom(value);
        } else {
          dirRev_ = value;
        }
      } else {
        dirRevBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if power flow is reversed
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS DirRev = 4;</code>
     */
    public Builder clearDirRev() {
      bitField0_ = (bitField0_ & ~0x00000008);
      dirRev_ = null;
      if (dirRevBuilder_ != null) {
        dirRevBuilder_.dispose();
        dirRevBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if power flow is reversed
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS DirRev = 4;</code>
     */
    public openfmb.commonmodule.PhaseSPS.Builder getDirRevBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getDirRevFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * True if power flow is reversed
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS DirRev = 4;</code>
     */
    public openfmb.commonmodule.PhaseSPSOrBuilder getDirRevOrBuilder() {
      if (dirRevBuilder_ != null) {
        return dirRevBuilder_.getMessageOrBuilder();
      } else {
        return dirRev_ == null ?
            openfmb.commonmodule.PhaseSPS.getDefaultInstance() : dirRev_;
      }
    }
    /**
     * <pre>
     * True if power flow is reversed
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS DirRev = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder> 
        getDirRevFieldBuilder() {
      if (dirRevBuilder_ == null) {
        dirRevBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder>(
                getDirRev(),
                getParentForChildren(),
                isClean());
        dirRev_ = null;
      }
      return dirRevBuilder_;
    }

    private openfmb.commonmodule.ENS_DynamicTestKind dynamicTest_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ENS_DynamicTestKind, openfmb.commonmodule.ENS_DynamicTestKind.Builder, openfmb.commonmodule.ENS_DynamicTestKindOrBuilder> dynamicTestBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 5;</code>
     * @return Whether the dynamicTest field is set.
     */
    public boolean hasDynamicTest() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 5;</code>
     * @return The dynamicTest.
     */
    public openfmb.commonmodule.ENS_DynamicTestKind getDynamicTest() {
      if (dynamicTestBuilder_ == null) {
        return dynamicTest_ == null ? openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance() : dynamicTest_;
      } else {
        return dynamicTestBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 5;</code>
     */
    public Builder setDynamicTest(openfmb.commonmodule.ENS_DynamicTestKind value) {
      if (dynamicTestBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        dynamicTest_ = value;
      } else {
        dynamicTestBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 5;</code>
     */
    public Builder setDynamicTest(
        openfmb.commonmodule.ENS_DynamicTestKind.Builder builderForValue) {
      if (dynamicTestBuilder_ == null) {
        dynamicTest_ = builderForValue.build();
      } else {
        dynamicTestBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 5;</code>
     */
    public Builder mergeDynamicTest(openfmb.commonmodule.ENS_DynamicTestKind value) {
      if (dynamicTestBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          dynamicTest_ != null &&
          dynamicTest_ != openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance()) {
          getDynamicTestBuilder().mergeFrom(value);
        } else {
          dynamicTest_ = value;
        }
      } else {
        dynamicTestBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 5;</code>
     */
    public Builder clearDynamicTest() {
      bitField0_ = (bitField0_ & ~0x00000010);
      dynamicTest_ = null;
      if (dynamicTestBuilder_ != null) {
        dynamicTestBuilder_.dispose();
        dynamicTestBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 5;</code>
     */
    public openfmb.commonmodule.ENS_DynamicTestKind.Builder getDynamicTestBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getDynamicTestFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 5;</code>
     */
    public openfmb.commonmodule.ENS_DynamicTestKindOrBuilder getDynamicTestOrBuilder() {
      if (dynamicTestBuilder_ != null) {
        return dynamicTestBuilder_.getMessageOrBuilder();
      } else {
        return dynamicTest_ == null ?
            openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance() : dynamicTest_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ENS_DynamicTestKind, openfmb.commonmodule.ENS_DynamicTestKind.Builder, openfmb.commonmodule.ENS_DynamicTestKindOrBuilder> 
        getDynamicTestFieldBuilder() {
      if (dynamicTestBuilder_ == null) {
        dynamicTestBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ENS_DynamicTestKind, openfmb.commonmodule.ENS_DynamicTestKind.Builder, openfmb.commonmodule.ENS_DynamicTestKindOrBuilder>(
                getDynamicTest(),
                getParentForChildren(),
                isClean());
        dynamicTest_ = null;
      }
      return dynamicTestBuilder_;
    }

    private openfmb.commonmodule.PhaseDPS pos_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseDPS, openfmb.commonmodule.PhaseDPS.Builder, openfmb.commonmodule.PhaseDPSOrBuilder> posBuilder_;
    /**
     * <pre>
     * (controllable) Position of the switch of power shunt.
     * </pre>
     *
     * <code>.commonmodule.PhaseDPS Pos = 6;</code>
     * @return Whether the pos field is set.
     */
    public boolean hasPos() {
      return ((bitField0_ & 0x00000020) != 0);
    }
    /**
     * <pre>
     * (controllable) Position of the switch of power shunt.
     * </pre>
     *
     * <code>.commonmodule.PhaseDPS Pos = 6;</code>
     * @return The pos.
     */
    public openfmb.commonmodule.PhaseDPS getPos() {
      if (posBuilder_ == null) {
        return pos_ == null ? openfmb.commonmodule.PhaseDPS.getDefaultInstance() : pos_;
      } else {
        return posBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * (controllable) Position of the switch of power shunt.
     * </pre>
     *
     * <code>.commonmodule.PhaseDPS Pos = 6;</code>
     */
    public Builder setPos(openfmb.commonmodule.PhaseDPS value) {
      if (posBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        pos_ = value;
      } else {
        posBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (controllable) Position of the switch of power shunt.
     * </pre>
     *
     * <code>.commonmodule.PhaseDPS Pos = 6;</code>
     */
    public Builder setPos(
        openfmb.commonmodule.PhaseDPS.Builder builderForValue) {
      if (posBuilder_ == null) {
        pos_ = builderForValue.build();
      } else {
        posBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (controllable) Position of the switch of power shunt.
     * </pre>
     *
     * <code>.commonmodule.PhaseDPS Pos = 6;</code>
     */
    public Builder mergePos(openfmb.commonmodule.PhaseDPS value) {
      if (posBuilder_ == null) {
        if (((bitField0_ & 0x00000020) != 0) &&
          pos_ != null &&
          pos_ != openfmb.commonmodule.PhaseDPS.getDefaultInstance()) {
          getPosBuilder().mergeFrom(value);
        } else {
          pos_ = value;
        }
      } else {
        posBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (controllable) Position of the switch of power shunt.
     * </pre>
     *
     * <code>.commonmodule.PhaseDPS Pos = 6;</code>
     */
    public Builder clearPos() {
      bitField0_ = (bitField0_ & ~0x00000020);
      pos_ = null;
      if (posBuilder_ != null) {
        posBuilder_.dispose();
        posBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (controllable) Position of the switch of power shunt.
     * </pre>
     *
     * <code>.commonmodule.PhaseDPS Pos = 6;</code>
     */
    public openfmb.commonmodule.PhaseDPS.Builder getPosBuilder() {
      bitField0_ |= 0x00000020;
      onChanged();
      return getPosFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * (controllable) Position of the switch of power shunt.
     * </pre>
     *
     * <code>.commonmodule.PhaseDPS Pos = 6;</code>
     */
    public openfmb.commonmodule.PhaseDPSOrBuilder getPosOrBuilder() {
      if (posBuilder_ != null) {
        return posBuilder_.getMessageOrBuilder();
      } else {
        return pos_ == null ?
            openfmb.commonmodule.PhaseDPS.getDefaultInstance() : pos_;
      }
    }
    /**
     * <pre>
     * (controllable) Position of the switch of power shunt.
     * </pre>
     *
     * <code>.commonmodule.PhaseDPS Pos = 6;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseDPS, openfmb.commonmodule.PhaseDPS.Builder, openfmb.commonmodule.PhaseDPSOrBuilder> 
        getPosFieldBuilder() {
      if (posBuilder_ == null) {
        posBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.PhaseDPS, openfmb.commonmodule.PhaseDPS.Builder, openfmb.commonmodule.PhaseDPSOrBuilder>(
                getPos(),
                getParentForChildren(),
                isClean());
        pos_ = null;
      }
      return posBuilder_;
    }

    private openfmb.commonmodule.PhaseSPS tempLmt_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder> tempLmtBuilder_;
    /**
     * <pre>
     * True if temperature limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS TempLmt = 7;</code>
     * @return Whether the tempLmt field is set.
     */
    public boolean hasTempLmt() {
      return ((bitField0_ & 0x00000040) != 0);
    }
    /**
     * <pre>
     * True if temperature limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS TempLmt = 7;</code>
     * @return The tempLmt.
     */
    public openfmb.commonmodule.PhaseSPS getTempLmt() {
      if (tempLmtBuilder_ == null) {
        return tempLmt_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : tempLmt_;
      } else {
        return tempLmtBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * True if temperature limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS TempLmt = 7;</code>
     */
    public Builder setTempLmt(openfmb.commonmodule.PhaseSPS value) {
      if (tempLmtBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        tempLmt_ = value;
      } else {
        tempLmtBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if temperature limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS TempLmt = 7;</code>
     */
    public Builder setTempLmt(
        openfmb.commonmodule.PhaseSPS.Builder builderForValue) {
      if (tempLmtBuilder_ == null) {
        tempLmt_ = builderForValue.build();
      } else {
        tempLmtBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if temperature limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS TempLmt = 7;</code>
     */
    public Builder mergeTempLmt(openfmb.commonmodule.PhaseSPS value) {
      if (tempLmtBuilder_ == null) {
        if (((bitField0_ & 0x00000040) != 0) &&
          tempLmt_ != null &&
          tempLmt_ != openfmb.commonmodule.PhaseSPS.getDefaultInstance()) {
          getTempLmtBuilder().mergeFrom(value);
        } else {
          tempLmt_ = value;
        }
      } else {
        tempLmtBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if temperature limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS TempLmt = 7;</code>
     */
    public Builder clearTempLmt() {
      bitField0_ = (bitField0_ & ~0x00000040);
      tempLmt_ = null;
      if (tempLmtBuilder_ != null) {
        tempLmtBuilder_.dispose();
        tempLmtBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if temperature limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS TempLmt = 7;</code>
     */
    public openfmb.commonmodule.PhaseSPS.Builder getTempLmtBuilder() {
      bitField0_ |= 0x00000040;
      onChanged();
      return getTempLmtFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * True if temperature limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS TempLmt = 7;</code>
     */
    public openfmb.commonmodule.PhaseSPSOrBuilder getTempLmtOrBuilder() {
      if (tempLmtBuilder_ != null) {
        return tempLmtBuilder_.getMessageOrBuilder();
      } else {
        return tempLmt_ == null ?
            openfmb.commonmodule.PhaseSPS.getDefaultInstance() : tempLmt_;
      }
    }
    /**
     * <pre>
     * True if temperature limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS TempLmt = 7;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder> 
        getTempLmtFieldBuilder() {
      if (tempLmtBuilder_ == null) {
        tempLmtBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder>(
                getTempLmt(),
                getParentForChildren(),
                isClean());
        tempLmt_ = null;
      }
      return tempLmtBuilder_;
    }

    private openfmb.commonmodule.PhaseSPS vArLmt_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder> vArLmtBuilder_;
    /**
     * <pre>
     * True if VAr limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VArLmt = 8;</code>
     * @return Whether the vArLmt field is set.
     */
    public boolean hasVArLmt() {
      return ((bitField0_ & 0x00000080) != 0);
    }
    /**
     * <pre>
     * True if VAr limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VArLmt = 8;</code>
     * @return The vArLmt.
     */
    public openfmb.commonmodule.PhaseSPS getVArLmt() {
      if (vArLmtBuilder_ == null) {
        return vArLmt_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : vArLmt_;
      } else {
        return vArLmtBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * True if VAr limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VArLmt = 8;</code>
     */
    public Builder setVArLmt(openfmb.commonmodule.PhaseSPS value) {
      if (vArLmtBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        vArLmt_ = value;
      } else {
        vArLmtBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if VAr limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VArLmt = 8;</code>
     */
    public Builder setVArLmt(
        openfmb.commonmodule.PhaseSPS.Builder builderForValue) {
      if (vArLmtBuilder_ == null) {
        vArLmt_ = builderForValue.build();
      } else {
        vArLmtBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if VAr limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VArLmt = 8;</code>
     */
    public Builder mergeVArLmt(openfmb.commonmodule.PhaseSPS value) {
      if (vArLmtBuilder_ == null) {
        if (((bitField0_ & 0x00000080) != 0) &&
          vArLmt_ != null &&
          vArLmt_ != openfmb.commonmodule.PhaseSPS.getDefaultInstance()) {
          getVArLmtBuilder().mergeFrom(value);
        } else {
          vArLmt_ = value;
        }
      } else {
        vArLmtBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if VAr limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VArLmt = 8;</code>
     */
    public Builder clearVArLmt() {
      bitField0_ = (bitField0_ & ~0x00000080);
      vArLmt_ = null;
      if (vArLmtBuilder_ != null) {
        vArLmtBuilder_.dispose();
        vArLmtBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if VAr limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VArLmt = 8;</code>
     */
    public openfmb.commonmodule.PhaseSPS.Builder getVArLmtBuilder() {
      bitField0_ |= 0x00000080;
      onChanged();
      return getVArLmtFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * True if VAr limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VArLmt = 8;</code>
     */
    public openfmb.commonmodule.PhaseSPSOrBuilder getVArLmtOrBuilder() {
      if (vArLmtBuilder_ != null) {
        return vArLmtBuilder_.getMessageOrBuilder();
      } else {
        return vArLmt_ == null ?
            openfmb.commonmodule.PhaseSPS.getDefaultInstance() : vArLmt_;
      }
    }
    /**
     * <pre>
     * True if VAr limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VArLmt = 8;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder> 
        getVArLmtFieldBuilder() {
      if (vArLmtBuilder_ == null) {
        vArLmtBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder>(
                getVArLmt(),
                getParentForChildren(),
                isClean());
        vArLmt_ = null;
      }
      return vArLmtBuilder_;
    }

    private openfmb.commonmodule.PhaseSPS volLmt_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder> volLmtBuilder_;
    /**
     * <pre>
     * True if voltage limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VolLmt = 9;</code>
     * @return Whether the volLmt field is set.
     */
    public boolean hasVolLmt() {
      return ((bitField0_ & 0x00000100) != 0);
    }
    /**
     * <pre>
     * True if voltage limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VolLmt = 9;</code>
     * @return The volLmt.
     */
    public openfmb.commonmodule.PhaseSPS getVolLmt() {
      if (volLmtBuilder_ == null) {
        return volLmt_ == null ? openfmb.commonmodule.PhaseSPS.getDefaultInstance() : volLmt_;
      } else {
        return volLmtBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * True if voltage limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VolLmt = 9;</code>
     */
    public Builder setVolLmt(openfmb.commonmodule.PhaseSPS value) {
      if (volLmtBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        volLmt_ = value;
      } else {
        volLmtBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000100;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if voltage limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VolLmt = 9;</code>
     */
    public Builder setVolLmt(
        openfmb.commonmodule.PhaseSPS.Builder builderForValue) {
      if (volLmtBuilder_ == null) {
        volLmt_ = builderForValue.build();
      } else {
        volLmtBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000100;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if voltage limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VolLmt = 9;</code>
     */
    public Builder mergeVolLmt(openfmb.commonmodule.PhaseSPS value) {
      if (volLmtBuilder_ == null) {
        if (((bitField0_ & 0x00000100) != 0) &&
          volLmt_ != null &&
          volLmt_ != openfmb.commonmodule.PhaseSPS.getDefaultInstance()) {
          getVolLmtBuilder().mergeFrom(value);
        } else {
          volLmt_ = value;
        }
      } else {
        volLmtBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000100;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if voltage limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VolLmt = 9;</code>
     */
    public Builder clearVolLmt() {
      bitField0_ = (bitField0_ & ~0x00000100);
      volLmt_ = null;
      if (volLmtBuilder_ != null) {
        volLmtBuilder_.dispose();
        volLmtBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * True if voltage limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VolLmt = 9;</code>
     */
    public openfmb.commonmodule.PhaseSPS.Builder getVolLmtBuilder() {
      bitField0_ |= 0x00000100;
      onChanged();
      return getVolLmtFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * True if voltage limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VolLmt = 9;</code>
     */
    public openfmb.commonmodule.PhaseSPSOrBuilder getVolLmtOrBuilder() {
      if (volLmtBuilder_ != null) {
        return volLmtBuilder_.getMessageOrBuilder();
      } else {
        return volLmt_ == null ?
            openfmb.commonmodule.PhaseSPS.getDefaultInstance() : volLmt_;
      }
    }
    /**
     * <pre>
     * True if voltage limit (high, low, or both) are set
     * </pre>
     *
     * <code>.commonmodule.PhaseSPS VolLmt = 9;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder> 
        getVolLmtFieldBuilder() {
      if (volLmtBuilder_ == null) {
        volLmtBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.PhaseSPS, openfmb.commonmodule.PhaseSPS.Builder, openfmb.commonmodule.PhaseSPSOrBuilder>(
                getVolLmt(),
                getParentForChildren(),
                isClean());
        volLmt_ = null;
      }
      return volLmtBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:capbankmodule.CapBankEventAndStatusYPSH)
  }

  // @@protoc_insertion_point(class_scope:capbankmodule.CapBankEventAndStatusYPSH)
  private static final openfmb.capbankmodule.CapBankEventAndStatusYPSH DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.capbankmodule.CapBankEventAndStatusYPSH();
  }

  public static openfmb.capbankmodule.CapBankEventAndStatusYPSH getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<CapBankEventAndStatusYPSH>
      PARSER = new com.google.protobuf.AbstractParser<CapBankEventAndStatusYPSH>() {
    @java.lang.Override
    public CapBankEventAndStatusYPSH parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<CapBankEventAndStatusYPSH> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<CapBankEventAndStatusYPSH> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.capbankmodule.CapBankEventAndStatusYPSH getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

